Index: issm/trunk/src/c/modules/ModelProcessorx/CreateDataSets.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateDataSets.cpp	(revision 4284)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateDataSets.cpp	(revision 4285)
@@ -58,4 +58,18 @@
 
 		case SlopeAnalysisEnum:
+			CreateNodesSlopeCompute(pnodes, iomodel,iomodel_handle);
+			CreateConstraintsSlopeCompute(pconstraints,iomodel,iomodel_handle);
+			CreateLoadsSlopeCompute(ploads,iomodel,iomodel_handle);
+			UpdateElementsSlopeCompute(elements,iomodel,iomodel_handle,analysis_counter,analysis_type);
+			break;
+		
+		case BedSlopeAnalysisEnum:
+			CreateNodesSlopeCompute(pnodes, iomodel,iomodel_handle);
+			CreateConstraintsSlopeCompute(pconstraints,iomodel,iomodel_handle);
+			CreateLoadsSlopeCompute(ploads,iomodel,iomodel_handle);
+			UpdateElementsSlopeCompute(elements,iomodel,iomodel_handle,analysis_counter,analysis_type);
+			break;
+
+		case SurfaceSlopeAnalysisEnum:
 			CreateNodesSlopeCompute(pnodes, iomodel,iomodel_handle);
 			CreateConstraintsSlopeCompute(pconstraints,iomodel,iomodel_handle);
Index: issm/trunk/src/c/objects/Elements/Penta.cpp
===================================================================
--- issm/trunk/src/c/objects/Elements/Penta.cpp	(revision 4284)
+++ issm/trunk/src/c/objects/Elements/Penta.cpp	(revision 4285)
@@ -324,5 +324,5 @@
 		InputUpdateFromSolutionDiagnosticStokes( solution);
 	}
-	else if (analysis_type==SlopeAnalysisEnum){
+	else if (analysis_type==BedSlopeAnalysisEnum || analysis_type==SurfaceSlopeAnalysisEnum){
 		InputUpdateFromSolutionSlopeCompute( solution);
 	}
@@ -664,5 +664,5 @@
 		CreateKMatrixDiagnosticStokes( Kgg);
 	}
-	else if (analysis_type==SlopeAnalysisEnum){
+	else if (analysis_type==BedSlopeAnalysisEnum || analysis_type==SurfaceSlopeAnalysisEnum){
 		CreateKMatrixSlopeCompute( Kgg);
 	}
@@ -714,5 +714,5 @@
 		CreatePVectorDiagnosticStokes( pg);
 	}
-	else if (analysis_type==SlopeAnalysisEnum){
+	else if (analysis_type==BedSlopeAnalysisEnum || analysis_type==SurfaceSlopeAnalysisEnum){
 		CreatePVectorSlopeCompute( pg);
 	}
Index: issm/trunk/src/c/objects/Elements/Sing.cpp
===================================================================
--- issm/trunk/src/c/objects/Elements/Sing.cpp	(revision 4284)
+++ issm/trunk/src/c/objects/Elements/Sing.cpp	(revision 4285)
@@ -31,11 +31,54 @@
 }
 /*}}}*/
-/*FUNCTION void Sing::Update(int index, IoModel* iomodel,int analysis_counter,int analysis_type);{{{1*/
-void Sing::Update(int index, IoModel* iomodel,int analysis_counter,int analysis_type){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
 
 /*Object virtual functions definitions: */
+/*FUNCTION Sing::copy {{{1*/
+Object* Sing::copy() {
+
+	int i;
+	Sing* sing=NULL;
+
+	sing=new Sing();
+
+	/*copy fields: */
+	sing->id=this->id;
+	if(this->inputs){
+		sing->inputs=(Inputs*)this->inputs->Copy();
+	}
+	else{
+		sing->inputs=new Inputs();
+	}
+	/*point parameters: */
+	sing->parameters=this->parameters;
+
+	/*pointers: */
+	sing->node=this->node;
+	sing->matice=this->matice;
+	sing->matpar=this->matpar;
+
+	return sing;
+}
+/*}}}*/
+/*FUNCTION Sing::DeepEcho {{{1*/
+void Sing::DeepEcho(void){
+
+	printf("Sing:\n");
+	printf("   id: %i\n",id);
+	node->DeepEcho();
+	matice->DeepEcho();
+	matpar->DeepEcho();
+	printf("   parameters\n");
+	parameters->DeepEcho();
+	printf("   inputs\n");
+	inputs->DeepEcho();
+
+	return;
+}
+/*}}}*/
+/*FUNCTION Sing::Demarshall {{{1*/
+void  Sing::Demarshall(char** pmarshalled_dataset){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
 /*FUNCTION Sing::Echo{{{1*/
 
@@ -53,22 +96,23 @@
 }
 /*}}}*/
-/*FUNCTION Sing::DeepEcho {{{1*/
-void Sing::DeepEcho(void){
-
-	printf("Sing:\n");
-	printf("   id: %i\n",id);
-	node->DeepEcho();
-	matice->DeepEcho();
-	matpar->DeepEcho();
-	printf("   parameters\n");
-	parameters->DeepEcho();
-	printf("   inputs\n");
-	inputs->DeepEcho();
-
-	return;
+/*FUNCTION Sing::Enum {{{1*/
+int Sing::Enum(void){
+
+	return SingEnum;
+
 }
 /*}}}*/
 /*FUNCTION Sing::Id {{{1*/
 int    Sing::Id(void){ return id; }
+/*}}}*/
+/*FUNCTION Sing::Marshall {{{1*/
+void  Sing::Marshall(char** pmarshalled_dataset){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::MashallSize {{{1*/
+int   Sing::MarshallSize(){
+	ISSMERROR(" not supported yet!");
+}
 /*}}}*/
 /*FUNCTION Sing::MyRank {{{1*/
@@ -78,55 +122,84 @@
 }
 /*}}}*/
-/*FUNCTION Sing::Marshall {{{1*/
-void  Sing::Marshall(char** pmarshalled_dataset){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::MashallSize {{{1*/
-int   Sing::MarshallSize(){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::Demarshall {{{1*/
-void  Sing::Demarshall(char** pmarshalled_dataset){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::Enum {{{1*/
-int Sing::Enum(void){
-
-	return SingEnum;
-
-}
-/*}}}*/
-/*FUNCTION Sing::copy {{{1*/
-Object* Sing::copy() {
-
-	int i;
-	Sing* sing=NULL;
-
-	sing=new Sing();
-
-	/*copy fields: */
-	sing->id=this->id;
-	if(this->inputs){
-		sing->inputs=(Inputs*)this->inputs->Copy();
-	}
-	else{
-		sing->inputs=new Inputs();
-	}
-	/*point parameters: */
-	sing->parameters=this->parameters;
-
-	/*pointers: */
-	sing->node=this->node;
-	sing->matice=this->matice;
-	sing->matpar=this->matpar;
-
-	return sing;
-}
-/*}}}*/
-
-/*Sing management*/
+
+/*Update virtual functions definitions: */
+/*FUNCTION Sing::InputUpdateFromSolution {{{1*/
+void  Sing::InputUpdateFromSolution(double* solution){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::InputUpdateFromVector(double* vector, int name, int type);{{{1*/
+void  Sing::InputUpdateFromVector(double* vector, int name, int type){
+
+	/*Check that name is an element input*/
+	if (!IsInput(name)) return;
+
+	switch(type){
+
+		case VertexEnum:
+
+			/*New SingVertexInpu*/
+			double value;
+
+			/*Get values on the 6 vertices*/
+			value=vector[node->GetVertexDof()];
+
+			/*update input*/
+			this->inputs->AddInput(new SingVertexInput(name,value));
+			return;
+
+		default:
+			ISSMERROR("type %i (%s) not implemented yet",type,EnumAsString(type));
+	}
+}
+/*}}}*/
+/*FUNCTION Sing::InputUpdateFromVector(int* vector, int name, int type);{{{1*/
+void  Sing::InputUpdateFromVector(int* vector, int name, int type){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::InputUpdateFromVector(bool* vector, int name, int type);{{{1*/
+void  Sing::InputUpdateFromVector(bool* vector, int name, int type){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+
+/*Element virtual functions definitions: */
+/*FUNCTION Sing::ComputeBasalStress {{{1*/
+void  Sing::ComputeBasalStress(Vec p_g){
+
+	ISSMERROR("Not implemented yet");
+
+}
+/*}}}*/
+/*FUNCTION Sing::ComputePressure {{{1*/
+void  Sing::ComputePressure(Vec p_g){
+
+	int    dof;
+	double pressure;
+	double thickness;
+	double rho_ice,g;
+
+	/*Get dof list on which we will plug the pressure values: */
+	GetDofList1(&dof);
+
+	/*pressure is lithostatic: */
+	rho_ice=matpar->GetRhoIce();
+	g=matpar->GetG();
+	inputs->GetParameterValue(&thickness,ThicknessEnum);
+	pressure=rho_ice*g*thickness;
+	
+	/*plug local pressure values into global pressure vector: */
+	VecSetValue(p_g,dof,pressure,INSERT_VALUES);
+
+}
+/*}}}*/
+/*FUNCTION Sing::ComputeStrainRate {{{1*/
+void  Sing::ComputeStrainRate(Vec p_g){
+
+	ISSMERROR("Not implemented yet");
+
+}
+/*}}}*/
 /*FUNCTION Sing::Configure {{{1*/
 void  Sing::Configure(Elements* elementsin,Loads* loadsin, DataSet* nodesin, Materials* materialsin, Parameters* parametersin){
@@ -136,4 +209,471 @@
 }
 /*}}}*/
+/*FUNCTION Sing::CostFunction {{{1*/
+double Sing::CostFunction(){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::CreateKMatrix {{{1*/
+
+void  Sing::CreateKMatrix(Mat Kgg){
+
+	int analysis_type;
+
+	/*retrive parameters: */
+	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
+
+	/*Just branch to the correct element stiffness matrix generator, according to the type of analysis we are carrying out: */
+	if (analysis_type==DiagnosticHutterAnalysisEnum){
+		CreateKMatrixDiagnosticHutter( Kgg);
+	}
+	else{
+		ISSMERROR("analysis %i (%s) not supported yet",analysis_type,EnumAsString(analysis_type));
+	}
+
+}
+/*}}}*/
+/*FUNCTION Sing::CreatePVector {{{1*/
+void  Sing::CreatePVector(Vec pg){
+
+	int analysis_type;
+
+	/*retrive parameters: */
+	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
+	
+	/*Just branch to the correct load generator, according to the type of analysis we are carrying out: */
+	if (analysis_type==DiagnosticHutterAnalysisEnum){
+			CreatePVectorDiagnosticHutter( pg);
+	}
+	else{
+		ISSMERROR("analysis %i (%s) not supported yet",analysis_type,EnumAsString(analysis_type));
+	}
+
+}
+/*}}}*/
+/*FUNCTION Sing::Du {{{1*/
+void  Sing::Du(Vec){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::GetBedList {{{1*/
+void  Sing::GetBedList(double*){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::GetMatPar {{{1*/
+void* Sing::GetMatPar(){
+
+	return matpar;
+}
+/*}}}*/
+/*FUNCTION Sing::GetNodes {{{1*/
+void  Sing::GetNodes(void** vpnodes){
+	
+	Node** pnodes=NULL;
+
+	/*recover nodes: */
+	pnodes=(Node**)vpnodes;
+
+	pnodes[0]=node;
+}
+/*}}}*/
+/*FUNCTION Sing::GetOnBed {{{1*/
+bool   Sing::GetOnBed(){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::GetShelf {{{1*/
+bool   Sing::GetShelf(){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::GetSolutionFromInputs(Vec solution);{{{1*/
+void  Sing::GetSolutionFromInputs(Vec solution){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::GetThicknessList {{{1*/
+void  Sing::GetThicknessList(double* thickness_list){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::GetVectorFromInputs(Vec vector,int NameEnum){{{1*/
+void  Sing::GetVectorFromInputs(Vec vector,int NameEnum){
+
+	int i;
+	const int numvertices=1;
+	int doflist1[numvertices];
+
+	/*Find NameEnum input in the inputs dataset, and get it to fill in the vector: */
+	for(i=0;i<this->inputs->Size();i++){
+		Input* input=(Input*)this->inputs->GetObjectByOffset(i);
+		if(input->EnumType()==NameEnum){
+			/*We found the enum.  Use its values to fill into the vector, using the vertices ids: */
+			this->GetDofList1(&doflist1[0]);
+			input->GetVectorFromInputs(vector,&doflist1[0]);
+			break;
+		}
+	}
+}
+/*}}}*/
+/*FUNCTION Sing::Gradj {{{1*/
+void  Sing::Gradj(Vec gradient,int control_type){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::GradB {{{1*/
+void  Sing::GradjB(Vec gradient){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::GradjDrag {{{1*/
+void  Sing::GradjDrag(Vec gradient){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::InputAXPY(int YEnum, double scalar, int XEnum);{{{1*/
+void  Sing::InputAXPY(int YEnum, double scalar, int XEnum){
+
+	Input* xinput=NULL;
+	Input* yinput=NULL;
+
+	/*Find x and y inputs: */
+	xinput=(Input*)this->inputs->GetInput(XEnum);
+	yinput=(Input*)this->inputs->GetInput(YEnum);
+
+	/*some checks: */
+	if(!xinput || !yinput)ISSMERROR("%s%s%s%s%s"," input ",EnumAsString(XEnum)," or input ",EnumAsString(YEnum)," could not be found!");
+	if(xinput->Enum()!=yinput->Enum())ISSMERROR("%s%s%s%s%s"," input ",EnumAsString(XEnum)," and input ",EnumAsString(YEnum)," are not of the same type!");
+
+	/*Scale: */
+	yinput->AXPY(xinput,scalar);
+}
+/*}}}*/
+/*FUNCTION Sing::InputControlConstrain(int control_type, double cm_min, double cm_max){{{1*/
+void  Sing::InputControlConstrain(int control_type, double cm_min, double cm_max){
+
+	Input* input=NULL;
+
+	/*Find input: */
+	input=(Input*)this->inputs->GetInput(control_type);
+	
+	/*Do nothing if we  don't find it: */
+	if(!input)return;
+
+	/*Constrain input using cm_min and cm_max: */
+	input->Constrain(cm_min,cm_max);
+
+}
+/*}}}*/
+/*FUNCTION Sing::InputConvergence(int* pconverged, double* eps, int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums){{{1*/
+void  Sing::InputConvergence(int* pconverged,double* eps, int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums){
+
+	int i;
+	Input** new_inputs=NULL;
+	Input** old_inputs=NULL;
+	int     converged=1;
+
+	new_inputs=(Input**)xmalloc(num_enums/2*sizeof(Input*)); //half the enums are for the new inputs
+	old_inputs=(Input**)xmalloc(num_enums/2*sizeof(Input*)); //half the enums are for the old inputs
+	
+	for(i=0;i<num_enums/2;i++){
+		new_inputs[i]=(Input*)this->inputs->GetInput(enums[2*i+0]);
+		old_inputs[i]=(Input*)this->inputs->GetInput(enums[2*i+1]);
+		if(!new_inputs[i])ISSMERROR("%s%s"," could not find input with enum ",EnumAsString(enums[2*i+0]));
+		if(!old_inputs[i])ISSMERROR("%s%s"," could not find input with enum ",EnumAsString(enums[2*i+0]));
+	}
+
+	/*ok, we've got the inputs (new and old), now loop throught the number of criterions and fill the eps array:*/
+	for(i=0;i<num_criterionenums;i++){
+		IsInputConverged(eps+i,new_inputs,old_inputs,num_enums/2,criterionenums[i]);
+		if(eps[i]>criterionvalues[i]) converged=0; 
+	}
+
+	/*Assign output pointers:*/
+	*pconverged=converged;
+
+}
+/*}}}*/
+/*FUNCTION Sing::InputDuplicate(int original_enum,int new_enum){{{1*/
+void  Sing::InputDuplicate(int original_enum,int new_enum){
+
+	Input* original=NULL;
+	Input* copy=NULL;
+
+	/*Make a copy of the original input: */
+	original=(Input*)this->inputs->GetInput(original_enum);
+	copy=(Input*)original->copy();
+
+	/*Change copy enum to reinitialized_enum: */
+	copy->ChangeEnum(new_enum);
+
+	/*Add copy into inputs, it will wipe off the one already there: */
+	inputs->AddObject((Input*)copy);
+}
+/*}}}*/
+/*FUNCTION Sing::InputScale(int enum_type,double scale_factor){{{1*/
+void  Sing::InputScale(int enum_type,double scale_factor){
+
+	Input* input=NULL;
+
+	/*Make a copy of the original input: */
+	input=(Input*)this->inputs->GetInput(enum_type);
+
+	/*Scale: */
+	input->Scale(scale_factor);
+}
+/*}}}*/
+/*FUNCTION Sing::InputToResult(int enum_type,int step,double time){{{1*/
+void  Sing::InputToResult(int enum_type,int step,double time){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::MassFlux {{{1*/
+double Sing::MassFlux( double* segment){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::MaxAbsVx(double* pmaxabsvx, bool process_units);{{{1*/
+void  Sing::MaxAbsVx(double* pmaxabsvx, bool process_units){
+
+	int dim;
+	double  maxabsvx;
+
+	/*retrieve dim parameter: */
+	parameters->FindParam(&dim,DimEnum);
+
+	/*retrive velocity values at nodes */
+	inputs->GetParameterValue(&maxabsvx,VxEnum);
+	maxabsvx=fabs(maxabsvx);
+
+	/*Assign output pointers:*/
+	*pmaxabsvx=maxabsvx;
+}
+/*}}}*/
+/*FUNCTION Sing::MaxAbsVy(double* pmaxabsvy, bool process_units);{{{1*/
+void  Sing::MaxAbsVy(double* pmaxabsvy, bool process_units){
+
+	int dim;
+	double  maxabsvy;
+
+	/*retrieve dim parameter: */
+	parameters->FindParam(&dim,DimEnum);
+
+	/*retrive velocity values at nodes */
+	inputs->GetParameterValue(&maxabsvy,VyEnum);
+	maxabsvy=fabs(maxabsvy);
+
+	/*Assign output pointers:*/
+	*pmaxabsvy=maxabsvy;
+}
+/*}}}*/
+/*FUNCTION Sing::MaxAbsVz(double* pmaxabsvz, bool process_units);{{{1*/
+void  Sing::MaxAbsVz(double* pmaxabsvz, bool process_units){
+
+	int dim;
+	double  maxabsvz;
+
+	/*retrieve dim parameter: */
+	parameters->FindParam(&dim,DimEnum);
+
+	/*retrive velocity values at nodes */
+	inputs->GetParameterValue(&maxabsvz,VzEnum);
+	maxabsvz=fabs(maxabsvz);
+
+	/*Assign output pointers:*/
+	*pmaxabsvz=maxabsvz;
+}
+/*}}}*/
+/*FUNCTION Sing::MaxVel(double* pmaxvel, bool process_units);{{{1*/
+void  Sing::MaxVel(double* pmaxvel, bool process_units){
+
+	int dim;
+	double  vx;
+	double  vy;
+	double  vz;
+	double  maxvel;
+
+	/*retrive velocity values at nodes */
+	inputs->GetParameterValue(&vx,VxEnum);
+	inputs->GetParameterValue(&vy,VyEnum);
+	if(dim==3)inputs->GetParameterValue(&vz,VzEnum);
+
+	/*now, compute maximum of velocity :*/
+	if(dim==2){
+		maxvel=sqrt(pow(vx,2)+pow(vy,2));
+	}
+	else{
+		maxvel=sqrt(pow(vx,2)+pow(vy,2)+pow(vz,2));
+	}
+
+	/*Assign output pointers:*/
+	*pmaxvel=maxvel;
+
+}
+/*}}}*/
+/*FUNCTION Sing::MaxVx(double* pmaxvx, bool process_units);{{{1*/
+void  Sing::MaxVx(double* pmaxvx, bool process_units){
+
+	int dim;
+	double  maxvx;
+
+	/*retrieve dim parameter: */
+	parameters->FindParam(&dim,DimEnum);
+
+	/*retrive velocity values at nodes */
+	inputs->GetParameterValue(&maxvx,VxEnum);
+
+	/*Assign output pointers:*/
+	*pmaxvx=maxvx;
+
+}
+/*}}}*/
+/*FUNCTION Sing::MaxVy(double* pmaxvy, bool process_units);{{{1*/
+void  Sing::MaxVy(double* pmaxvy, bool process_units){
+
+	int dim;
+	double  maxvy;
+
+	/*retrieve dim parameter: */
+	parameters->FindParam(&dim,DimEnum);
+
+	/*retrive velocity values at nodes */
+	inputs->GetParameterValue(&maxvy,VyEnum);
+
+	/*Assign output pointers:*/
+	*pmaxvy=maxvy;
+
+}
+/*}}}*/
+/*FUNCTION Sing::MaxVz(double* pmaxvz, bool process_units);{{{1*/
+void  Sing::MaxVz(double* pmaxvz, bool process_units){
+
+	int dim;
+	double  maxvz;
+
+	/*retrieve dim parameter: */
+	parameters->FindParam(&dim,DimEnum);
+
+	/*retrive velocity values at nodes */
+	inputs->GetParameterValue(&maxvz,VzEnum);
+
+	/*Assign output pointers:*/
+	*pmaxvz=maxvz;
+
+}
+/*}}}*/
+/*FUNCTION Sing::MinVel(double* pminvel, bool process_units);{{{1*/
+void  Sing::MinVel(double* pminvel, bool process_units){
+
+	int dim;
+	double  vx;
+	double  vy;
+	double  vz;
+	double  minvel;
+
+	/*retrive velocity values at nodes */
+	inputs->GetParameterValue(&vx,VxEnum);
+	inputs->GetParameterValue(&vy,VyEnum);
+	if(dim==3)inputs->GetParameterValue(&vz,VzEnum);
+
+	/*now, compute minimum of velocity :*/
+	if(dim==2){
+		minvel=sqrt(pow(vx,2)+pow(vy,2));
+	}
+	else{
+		minvel=sqrt(pow(vx,2)+pow(vy,2)+pow(vz,2));
+	}
+
+	/*Assign output pointers:*/
+	*pminvel=minvel;
+
+}
+/*}}}*/
+/*FUNCTION Sing::MinVx(double* pminvx, bool process_units);{{{1*/
+void  Sing::MinVx(double* pminvx, bool process_units){
+
+	int dim;
+	double  minvx;
+
+	/*retrieve dim parameter: */
+	parameters->FindParam(&dim,DimEnum);
+
+	/*retrive velocity values at nodes */
+	inputs->GetParameterValue(&minvx,VxEnum);
+
+	/*Assign output pointers:*/
+	*pminvx=minvx;
+
+}
+/*}}}*/
+/*FUNCTION Sing::MinVy(double* pminvy, bool process_units);{{{1*/
+void  Sing::MinVy(double* pminvy, bool process_units){
+
+	int dim;
+	double  minvy;
+
+	/*retrieve dim parameter: */
+	parameters->FindParam(&dim,DimEnum);
+
+	/*retrive velocity values at nodes */
+	inputs->GetParameterValue(&minvy,VyEnum);
+
+	/*Assign output pointers:*/
+	*pminvy=minvy;
+
+}
+/*}}}*/
+/*FUNCTION Sing::MinVz(double* pminvz, bool process_units);{{{1*/
+void  Sing::MinVz(double* pminvz, bool process_units){
+
+	int dim;
+	double  minvz;
+
+	/*retrieve dim parameter: */
+	parameters->FindParam(&dim,DimEnum);
+
+	/*retrive velocity values at nodes */
+	inputs->GetParameterValue(&minvz,VzEnum);
+
+	/*Assign output pointers:*/
+	*pminvz=minvz;
+
+}
+/*}}}*/
+/*FUNCTION Sing::Misfit {{{1*/
+double Sing::Misfit(void){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::PatchFill(int* pcount, Patch* patch){{{1*/
+void  Sing::PatchFill(int* pcount, Patch* patch){
+	
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::PatchSize(int* pnumrows, int* pnumvertices,int* pnumnodes){{{1*/
+void  Sing::PatchSize(int* pnumrows, int* pnumvertices,int* pnumnodes){
+
+	ISSMERROR(" not supported yet!");
+	
+}
+/*}}}*/
+/*FUNCTION Sing::ProcessResultsUnits(void){{{1*/
+void  Sing::ProcessResultsUnits(void){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::SurfaceArea {{{1*/
+double Sing::SurfaceArea( void){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Sing::Update(int index, IoModel* iomodel,int analysis_counter,int analysis_type);{{{1*/
+void Sing::Update(int index, IoModel* iomodel,int analysis_counter,int analysis_type){
+	ISSMERROR(" not supported yet!");
+}
+/*}}}*/
+
+/*Sing specific routines: */
 /*FUNCTION Sing::IsInput{{{1*/
 bool Sing::IsInput(int name){
@@ -143,86 +683,4 @@
 	}
 	else return false;
-}
-/*}}}*/
-/*FUNCTION Sing::InputUpdateFromSolution {{{1*/
-void  Sing::InputUpdateFromSolution(double* solution){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::GetSolutionFromInputs(Vec solution);{{{1*/
-void  Sing::GetSolutionFromInputs(Vec solution){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::InputToResult(int enum_type,int step,double time){{{1*/
-void  Sing::InputToResult(int enum_type,int step,double time){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::ProcessResultsUnits(void){{{1*/
-void  Sing::ProcessResultsUnits(void){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-		
-/*Sing functions*/
-/*FUNCTION Sing::ComputeBasalStress {{{1*/
-void  Sing::ComputeBasalStress(Vec p_g){
-
-	ISSMERROR("Not implemented yet");
-
-}
-/*}}}*/
-/*FUNCTION Sing::ComputePressure {{{1*/
-void  Sing::ComputePressure(Vec p_g){
-
-	int    dof;
-	double pressure;
-	double thickness;
-	double rho_ice,g;
-
-	/*Get dof list on which we will plug the pressure values: */
-	GetDofList1(&dof);
-
-	/*pressure is lithostatic: */
-	rho_ice=matpar->GetRhoIce();
-	g=matpar->GetG();
-	inputs->GetParameterValue(&thickness,ThicknessEnum);
-	pressure=rho_ice*g*thickness;
-	
-	/*plug local pressure values into global pressure vector: */
-	VecSetValue(p_g,dof,pressure,INSERT_VALUES);
-
-}
-/*}}}*/
-/*FUNCTION Sing::ComputeStrainRate {{{1*/
-void  Sing::ComputeStrainRate(Vec p_g){
-
-	ISSMERROR("Not implemented yet");
-
-}
-/*}}}*/
-/*FUNCTION Sing::CostFunction {{{1*/
-double Sing::CostFunction(){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::CreateKMatrix {{{1*/
-
-void  Sing::CreateKMatrix(Mat Kgg){
-
-	int analysis_type;
-
-	/*retrive parameters: */
-	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
-
-	/*Just branch to the correct element stiffness matrix generator, according to the type of analysis we are carrying out: */
-	if (analysis_type==DiagnosticHutterAnalysisEnum){
-		CreateKMatrixDiagnosticHutter( Kgg);
-	}
-	else{
-		ISSMERROR("analysis %i (%s) not supported yet",analysis_type,EnumAsString(analysis_type));
-	}
-
 }
 /*}}}*/
@@ -246,22 +704,4 @@
 
 	MatSetValues(Kgg,numdofs,doflist,numdofs,doflist,(const double*)Ke_gg,ADD_VALUES);
-
-}
-/*}}}*/
-/*FUNCTION Sing::CreatePVector {{{1*/
-void  Sing::CreatePVector(Vec pg){
-
-	int analysis_type;
-
-	/*retrive parameters: */
-	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
-	
-	/*Just branch to the correct load generator, according to the type of analysis we are carrying out: */
-	if (analysis_type==DiagnosticHutterAnalysisEnum){
-			CreatePVectorDiagnosticHutter( pg);
-	}
-	else{
-		ISSMERROR("analysis %i (%s) not supported yet",analysis_type,EnumAsString(analysis_type));
-	}
 
 }
@@ -317,14 +757,4 @@
 }
 /*}}}*/
-/*FUNCTION Sing::Du {{{1*/
-void  Sing::Du(Vec){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::GetBedList {{{1*/
-void  Sing::GetBedList(double*){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
 /*FUNCTION Sing::GetDofList {{{1*/
 void  Sing::GetDofList(int* doflist,int* pnumberofdofspernode){
@@ -352,66 +782,4 @@
 }
 /*}}}*/
-/*FUNCTION Sing::GetMatPar {{{1*/
-void* Sing::GetMatPar(){
-
-	return matpar;
-}
-/*}}}*/
-/*FUNCTION Sing::GetNodes {{{1*/
-void  Sing::GetNodes(void** vpnodes){
-	
-	Node** pnodes=NULL;
-
-	/*recover nodes: */
-	pnodes=(Node**)vpnodes;
-
-	pnodes[0]=node;
-}
-/*}}}*/
-/*FUNCTION Sing::GetOnBed {{{1*/
-bool   Sing::GetOnBed(){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::GetShelf {{{1*/
-bool   Sing::GetShelf(){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::GetThicknessList {{{1*/
-void  Sing::GetThicknessList(double* thickness_list){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::Gradj {{{1*/
-void  Sing::Gradj(Vec gradient,int control_type){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::GradB {{{1*/
-void  Sing::GradjB(Vec gradient){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::GradjDrag {{{1*/
-void  Sing::GradjDrag(Vec gradient){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::MassFlux {{{1*/
-double Sing::MassFlux( double* segment){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::Misfit {{{1*/
-double Sing::Misfit(void){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
-/*FUNCTION Sing::SurfaceArea {{{1*/
-double Sing::SurfaceArea( void){
-	ISSMERROR(" not supported yet!");
-}
-/*}}}*/
 /*FUNCTION Sing::SetClone {{{1*/
 void  Sing::SetClone(int* minranks){
